-- all credits belong to Swordslayer -> http://www.scriptspot.com/forums/3ds-max/general-scripting/open-all-groups-and-sub-groups

-- i use STRG+G for closing groups and STRG+SHIFT+G for opening groups!


macroScript OPEN_ALL_GROUPS Category:"Custom" toolTip:"open all groups" (
	fn openGroupsAll objs toggle1 toggle2= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle1
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll objects true true
)

macroScript OPEN_VISIBLE_GROUPS Category:"Custom" toolTip:"open visible groups" (
	fn openGroupsAll objs toggle1 toggle2= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o AND (o.isHidden != toggle2) collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle1
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll objects true true
)

macroScript CLOSE_ALL_GROUPS Category:"Custom" toolTip:"close all groups"
(
	fn openGroupsAll objs toggle1 toggle2= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle1
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll objects false true
)


macroScript CLOSE_VISIBLE_GROUPS Category:"Custom" toolTip:"close visible groups"
(
	fn openGroupsAll objs toggle1 toggle2= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o AND (o.isHidden != toggle2) collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle1
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll objects false true
)


macroScript OPEN_ALL_GROUPS_OF_SELECTION Category:"Custom" toolTip:"open selected groups" (
	fn openGroupsAll objs toggle1 toggle2= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle1
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll selection true true
)

macroScript CLOSE_ALL_GROUPS_OF_SELECTION Category:"Custom" toolTip:"close selected groups" (
	fn openGroupsAll objs toggle1 toggle2= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle1
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll selection false true
)


messagebox("Actions are stored in Category: \"Custom\"")
